#!/usr/bin/env bash

SNUGLOG_DIR=.

if [ $# -ge 1 ]; then
  SNUGLOG_DIR=$1
fi

SNUGLOG_DIR=$(realpath "$SNUGLOG_DIR")

source "$SNUGLOG_DIR/tools/config/defaults"

if [ $# -ge 2 ]; then
  source "$2"
elif [ -f "$SNUGLOG_DIR/tools/config/override" ]; then
  source "$SNUGLOG_DIR/tools/config/override"
fi

if test "$MUST_REWRITE_PATHS" -eq 1 && test ! "$REWRITE_ENABLED" && [[ ! "$1" =~ /\s/g ]] && [[ ! "$2" =~ /\s/g ]]; then
  export REWRITE_ENABLED=1
  (echo "$0 $@" | /usr/bin/env bash) 2>&1 | sed $REWRITE_PATHS
  export REWRITE_ENABLED=0
else
  # Execute doxygen in the correct directory
  cd "$SNUGLOG_DIR" || exit 42
  "$DOXYGEN" "$DOXYFILE"
fi